package cz.vsb.jtestserver.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.LoginForm;
import cz.vsb.jtestserver.service.IAuthentication;
import cz.vsb.jtestserver.service.InvalidLoginException;
import cz.vsb.jtestserver.service.SecurityService;
import cz.vsb.jtestserver.view.UserView;

public class LoginAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws InvalidLoginException {
		ActionForward forward = null;
		UserView userView = null;

		// Get the credentials from the LoginForm
		String login = ((LoginForm) form).getLogin();
		String pass = ((LoginForm) form).getPass();

		IAuthentication service = new SecurityService();

		// Attempt to login
		userView = service.login(login, pass);

		// Since an exception wasn't thrown, login was successful

		// Invalidate existing session if it exists
		HttpSession session = request.getSession(false);
		if (session != null) {
			session.invalidate();
		}

		// Create a new session for this user
		session = request.getSession(true);

		// Store the UserView into the session and return
		session.setAttribute(IConstants.USER_VIEW_KEY, userView);
		forward = mapping.findForward(IConstants.SUCCESS_KEY);
		return forward;
	}
}
