package cz.vsb.jtestserver.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.service.CviceniManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.HodinaView;

public class OdstranitCviceniAction extends Action {

	static Logger logger = Logger.getLogger(OdstranitCviceniAction.class);
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			HodinaView hodinaView = (HodinaView) request.getSession()
					.getAttribute(IConstants.HODINA_VIEW_KEY);
			int idCviceni;
			try {
				idCviceni = Integer.parseInt(request.getParameter("idCviceni"));
			} catch (NumberFormatException e) {
				logger.error(e);
				return mapping.findForward(IConstants.FAILURE_KEY);
			}
			CviceniManager man = new CviceniManager();
			man.deleteCviceni(idCviceni, hodinaView.getId());
			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}

}
