package cz.vsb.jtestserver.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.PridatMetoduForm;
import cz.vsb.jtestserver.service.MetodaManager;
import cz.vsb.jtestserver.util.ServerUtil;

public class PridatMetoduAction extends Action {

	static Logger logger = Logger.getLogger(PridatMetoduAction.class);
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		PridatMetoduForm frm = (PridatMetoduForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			String idMetodyRequest = request.getParameter("idMetody");

			if (idMetodyRequest != null) {
				int idMetody;
				try {
					idMetody = Integer.parseInt(idMetodyRequest);
				} catch (NumberFormatException e) {
					logger.error(e);
					return mapping.findForward(IConstants.FAILURE_KEY);
				}
				MetodaManager mm = new MetodaManager();
				frm.naplnit(mm.findMetodu(idMetody));
			} else {
				int idUlohy;
				try {
					idUlohy = Integer.parseInt(request.getParameter("idUlohy"));
				} catch (NumberFormatException e) {
					logger.error(e);
					return mapping.findForward(IConstants.FAILURE_KEY);
				}
				frm.setIdUlohy(idUlohy);
			}
			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}

}
