package cz.vsb.jtestserver.action;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.PridatUlohaCviceniForm;
import cz.vsb.jtestserver.service.CviceniManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.CviceniView;
import cz.vsb.jtestserver.view.UlohaView;

public class PridatUlohaCviceniAction extends Action {
	static Logger logger = Logger.getLogger(PridatUlohaCviceniAction.class);
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		PridatUlohaCviceniForm frm = (PridatUlohaCviceniForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			CviceniView cviceniView = (CviceniView) request.getSession()
					.getAttribute(IConstants.CVICENI_VIEW_KEY);
			String idCviceniRequest = request.getParameter("idCviceni");

			if (idCviceniRequest != null) {
				int idCviceni;
				try {
					idCviceni = Integer.parseInt(idCviceniRequest);
				} catch (NumberFormatException e) {
					logger.error(e);
					return mapping.findForward(IConstants.FAILURE_KEY);
				}
				CviceniManager cm = new CviceniManager();
				List<UlohaView> ulohy = cm.findUlohyCviceniAdd(idCviceni);
				frm.setUlohy(ulohy);
				frm.setIdCviceni(cviceniView.getIdCviceni());
			}
			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}
}
