package cz.vsb.jtestserver.action;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.RozvrhHodinForm;
import cz.vsb.jtestserver.service.HodinaManager;
import cz.vsb.jtestserver.service.PredmetManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UserView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

public class RozvhHodinAction extends Action {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		RozvrhHodinForm hlsform = (RozvrhHodinForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);
			String kodPredmetu = request.getParameter("kod");
			// Pokud je uzivatel studentem
			if (userView.getStatus().equals(IConstants.STATUS_STUDENT)) {
				PredmetManager mm = new PredmetManager(userView);
				PredmetView predmety = mm.findPredmet(kodPredmetu);

				HttpSession session = request.getSession(false);
				if (session != null) {
					session.invalidate();
				}
				session = request.getSession(true);
				session.setAttribute(IConstants.PREDMET_VIEW_KEY, predmety);
				session.setAttribute(IConstants.USER_VIEW_KEY, userView);
			}

			HodinaManager hm = new HodinaManager();
			hlsform.setHodiny(hm.findHodiny(kodPredmetu));

			PredmetManager pm = new PredmetManager(userView);
			hlsform.setPredmet(pm.findPredmet(kodPredmetu));

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}

}
