package cz.vsb.jtestserver.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.PridatUlohuForm;
import cz.vsb.jtestserver.service.UlohaManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UserView;

public class SavePridatUlohuAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		PridatUlohuForm ulohaform = (PridatUlohuForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);
			PredmetView predmetView = (PredmetView) request.getSession()
					.getAttribute(IConstants.PREDMET_VIEW_KEY);

			Integer idUlohy = ulohaform.getIdUlohy();
			UlohaManager um = new UlohaManager(userView);
			if (idUlohy == null || idUlohy == 0) {
				String nazevUlohy = ulohaform.getNazevUlohy();
				String popisUlohy = ulohaform.getPopisUlohy();
				String textUlohy = ulohaform.getTextUlohy();
				String jmenoTridy = ulohaform.getJmenoTridy();
				um.addUloha(nazevUlohy, popisUlohy, textUlohy, jmenoTridy,
						predmetView);
			} else {
				um.updateUloha(ulohaform.getIdUlohy(), 
						ulohaform.getNazevUlohy(), ulohaform.getPopisUlohy(),
						ulohaform.getTextUlohy(), ulohaform.getJmenoTridy(), 
						predmetView);
			}
			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}

}
