package cz.vsb.jtestserver.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;


import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.PridatZdrojovySouborUlohaForm;
import cz.vsb.jtestserver.service.FileNotCompiledException;
import cz.vsb.jtestserver.service.FileNotLoadedException;
import cz.vsb.jtestserver.service.FileUploadManager;
import cz.vsb.jtestserver.service.InvalidFileNameException;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UserView;

public class SavePridatZdrojovySouborUlohaAction extends Action {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws InvalidFileNameException, FileNotCompiledException, FileNotLoadedException {
		PridatZdrojovySouborUlohaForm uploadform = (PridatZdrojovySouborUlohaForm) form;

		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);
			PredmetView predmetView = (PredmetView) request.getSession()
					.getAttribute(IConstants.PREDMET_VIEW_KEY);

			FormFile file = uploadform.getFile();
			Integer idUlohy = uploadform.getIdUlohy();
			FileUploadManager fum = new FileUploadManager(userView, predmetView);
			fum.fileUpload(file, idUlohy);

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}
}
