package cz.vsb.jtestserver.action;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.ZobrazitPredmetForm;
import cz.vsb.jtestserver.service.PredmetManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UserView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

public class ZobrazitPredmetAction extends Action {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		ZobrazitPredmetForm hlsform = (ZobrazitPredmetForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);

			String kodPredmetu = request.getParameter("kod");
			PredmetManager mm = new PredmetManager(userView);
			PredmetView predmety = mm.findPredmet(kodPredmetu);
			hlsform.setPredmet(predmety);
			
			HttpSession session = request.getSession(false);
			if (session != null) {
				session.invalidate();
			}
			session = request.getSession(true);
			session.setAttribute(IConstants.PREDMET_VIEW_KEY, predmety);
			session.setAttribute(IConstants.USER_VIEW_KEY, userView);

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}

}
