package cz.vsb.jtestserver.action;

import java.util.List;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.form.ZobrazitUlohuForm;
import cz.vsb.jtestserver.service.PredmetManager;
import cz.vsb.jtestserver.service.UlohaManager;
import cz.vsb.jtestserver.util.ServerUtil;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UlohaView;
import cz.vsb.jtestserver.view.UserView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;

public class ZobrazitUlohuAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {
		ZobrazitUlohuForm hlsform = (ZobrazitUlohuForm) form;
		ActionForward forward = null;

		if (!ServerUtil.isLoggedIn(request)) {
			forward = mapping.findForward(IConstants.SESSION_TIME_OUT_KEY);
		} else {
			UserView userView = (UserView) request.getSession().getAttribute(
					IConstants.USER_VIEW_KEY);

			String kodPredmetu = request.getParameter("kod");
			// Pokud je uzivatel ucitelem
			if (userView.getStatus().equals(IConstants.STATUS_UCITEL)) {
				PredmetManager mm = new PredmetManager(userView);
				PredmetView predmety = mm.findPredmet(kodPredmetu);

				HttpSession session = request.getSession(false);
				if (session != null) {
					session.invalidate();
				}
				session = request.getSession(true);
				session.setAttribute(IConstants.PREDMET_VIEW_KEY, predmety);
				session.setAttribute(IConstants.USER_VIEW_KEY, userView);
			}
			UlohaManager um = new UlohaManager(userView);
			List<UlohaView> ulohy = um.findUlohy(kodPredmetu);
			hlsform.setUlohy(ulohy);

			forward = mapping.findForward(IConstants.SUCCESS_KEY);
		}
		return forward;
	}
}
