package cz.vsb.jtestserver.form;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.upload.FormFile;

public class PridatTestovanySouborForm extends ActionForm {
	
	private static final long serialVersionUID = 1L;
	private FormFile file;
	private Integer idUlohy;
	private final String JAVA_FILE = ".java";
	private String xmlFile;
	
	public void setIdUlohy(Integer idUlohy){
		this.idUlohy = idUlohy;
	}
	
	public Integer getIdUlohy(){
		return idUlohy;
	}
	public void setFile(FormFile iFile){
		this.file = iFile;
	}
	
	public FormFile getFile(){
		return this.file;
	}
	
	public String getXmlFile() {
		return xmlFile;
	}

	public void setXmlFile(String xmlFile) {
		this.xmlFile = xmlFile;
	}

	public ActionErrors validate(ActionMapping mapping, HttpServletRequest request){
		ActionErrors errors = new ActionErrors();
		
		
		if(isRequestSize(file.getFileSize()) == false ){
			errors.add(ActionMessages.GLOBAL_MESSAGE , new ActionMessage("maxLengthExceeded"));
		}
		
		if((file.getFileName() == null) || (file.getFileName().length() == 0)){
			errors.add(ActionMessages.GLOBAL_MESSAGE ,new ActionMessage("file.required"));
		}
		
		if(isJavaFile(file.getFileName()) == false){
			errors.add(ActionMessages.GLOBAL_MESSAGE ,new ActionMessage("file.not.javafile"));
		}
		
		return errors;
	}
	
	private boolean isJavaFile(String fileName){
		return fileName.endsWith(JAVA_FILE);
	}
	
	private boolean isRequestSize(int size){
		return size <= 0xf4240;
	}
}