package cz.vsb.jtestserver.service;

import cz.vsb.jtestserver.util.Database;
import cz.vsb.jtestserver.view.CviceniView;
import cz.vsb.jtestserver.view.UlohaView;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

public class CviceniManager {

	static Logger logger = Logger.getLogger(CviceniManager.class);
	
	public List<Integer> findVolnaCviceni(int idHodiny) {
		ArrayList<Integer> metody = new ArrayList<Integer>();
		Connection con = null;
		try {
			con = Database.getConnection();
			boolean obsahuje = false;
			for (int i = 1; i < 15; i++) {
				String query = "SELECT cislo_cviceni FROM cviceni WHERE id_rozvrhu = "
					+ idHodiny;
				logger.debug(query);
				Statement sql = con.createStatement();
				ResultSet result = sql.executeQuery(query);
				while (result.next()) {
					int cislo_cviceni = result.getInt(1);
					if (i == cislo_cviceni)
						obsahuje = true;
				}
				if (!obsahuje) {
					metody.add(i);
				}
				obsahuje = false;
                                result.close();
                                sql.close();
			}
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return metody;
	}

	public void addcviceni(int idRozvrhu, int cisloCviceni,
			String nazevCviceni, String popisCviceni) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "INSERT INTO cviceni VALUES(null, ?, ?, ?, ?)";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setInt(1, idRozvrhu);
			sql.setInt(2, cisloCviceni);
			sql.setString(3, nazevCviceni);
			sql.setString(4, popisCviceni);
			sql.executeUpdate();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public CviceniView findCviceni(int idCviceni) {
		CviceniView cviceni = null;
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT * FROM cviceni WHERE id_cviceni = "
				+ idCviceni;
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			if (result.next()) {
				cviceni = createCviceniFormRS(result);
			}
                        result.close();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return cviceni;
	}

	public boolean getOnLine(int idCviceni, int idHodiny) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT id_cviceni FROM online WHERE id_cviceni="
				+ idCviceni + " AND id_rozvrhu=" + idHodiny;
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
                        boolean stav = false;
			if (result.next()) {
				stav=true;
			}
                        result.close();
                        sql.close();
                        con.close();
                        return stav;
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return false;
	}

	public void updateCviceni(int idCviceni, int idRozvrhu, 
			Integer cisloCviceni, String popisCviceni, String nazevCviceni) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "UPDATE cviceni SET nazev_cviceni = ?, "
				+ "popis_cviceni = ?, cislo_cviceni = ? WHERE id_cviceni = ?";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setString(1, nazevCviceni);
			sql.setString(2, popisCviceni);
			sql.setInt(3, cisloCviceni);
			sql.setInt(4, idCviceni);
			sql.executeUpdate();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void deleteCviceni(int idCviceni, int idRozvrhu) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "DELETE FROM cviceni WHERE id_rozvrhu = ? AND id_cviceni = ?";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setInt(1, idRozvrhu);
			sql.setInt(2, idCviceni);
			sql.executeUpdate();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	/**
	 * Nalezeni vsech uloh, ktere jsou volne pro predmet 
	 * a jsou pridane testy k cviceni
	 */
	public List<UlohaView> findUlohyCviceniAdd(int idCviceni) {
		ArrayList<UlohaView> ulohy = new ArrayList<UlohaView>();
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT u.* FROM rozvrh r,cviceni c,uloha u " +
                            " WHERE r.id = c.id_rozvrhu " +
                            " AND r.predmet = u.predmet "  +     
                            " AND c.id_cviceni =  " + idCviceni + " " +
                            " AND testy = 'A'";
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			while (result.next()) {
				ulohy.add(createUlohaFormRS(result));
			}
                        result.close();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return ulohy;
	}

	public List<UlohaView> findUlohyCviceni(int idCviceni) {
		ArrayList<UlohaView> ulohy = new ArrayList<UlohaView>();
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT U.* FROM uloha U, cviceni_uloha CU, cviceni C "
				+ "WHERE C.id_cviceni = CU.id_cviceni AND CU.id_ulohy = U.id_ulohy AND C.id_cviceni = " + idCviceni;
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			while (result.next()) {
				ulohy.add(createUlohaFormRS(result));
			}
                        result.close();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return ulohy;
	}

	public void addUlohaCviceni(int idCviceni, int idUlohy) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "INSERT INTO cviceni_uloha VALUES(?, ?)";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setInt(1, idCviceni);
			sql.setInt(2, idUlohy);
			sql.executeUpdate();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void deleteUlohaCviceni(int idCviceni, int idUlohy) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "DELETE FROM cviceni_uloha WHERE id_cviceni = ? AND id_ulohy = ?";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setInt(1, idCviceni);
			sql.setInt(2, idUlohy);
			sql.executeUpdate();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void setCviceniOnLine(int idRozvrhu, int idCviceni) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "INSERT INTO online VALUES(?, ?)";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setInt(1, idRozvrhu);
			sql.setInt(2, idCviceni);
			sql.executeUpdate();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void setCviceniOffLine(int idRozvrhu, int idCviceni) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "DELETE FROM online WHERE id_rozvrhu=? AND id_cviceni=?";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setInt(1, idRozvrhu);
			sql.setInt(2, idCviceni);
			sql.executeUpdate();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	private CviceniView createCviceniFormRS(ResultSet rs) throws SQLException {
		CviceniView cView = new CviceniView();
		cView.setIdCviceni(rs.getInt("id_cviceni"));
		cView.setIdRozvrhu(rs.getInt("id_rozvrhu"));
		cView.setCisloCviceni(rs.getInt("cislo_cviceni"));
		cView.setNazevCviceni(rs.getString("nazev_cviceni"));
		cView.setPopisCviceni(rs.getString("popis_cviceni"));
		return cView;
	}

	private UlohaView createUlohaFormRS(ResultSet rs) throws SQLException {
		UlohaView ulohaView = new UlohaView();
		ulohaView.setIdUlohy(rs.getInt("id_ulohy"));
		ulohaView.setNazevUlohy(rs.getString("nazev_ulohy"));
		ulohaView.setPopisUlohy(rs.getString("popis_ulohy"));
		ulohaView.setTextUlohy(rs.getString("text_ulohy"));
		ulohaView.setJmenoTridy(rs.getString("jmeno_tridy"));
		ulohaView.setPredmet(rs.getString("predmet"));
		ulohaView.setVlozeno(rs.getString("vlozeno"));
		ulohaView.setLogin(rs.getString("login"));
		ulohaView.setKompilace(rs.getString("kompilace"));
		ulohaView.setTesty(rs.getString("testy"));
		return ulohaView;
	}
}
