package cz.vsb.jtestserver.service;

import cz.vsb.jtestserver.IConstants;
import cz.vsb.jtestserver.util.Configuration;
import cz.vsb.jtestserver.util.Database;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UserView;

import java.io.File;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

public class PredmetManager {

    static Logger logger = Logger.getLogger(PredmetManager.class);

    private UserView userView;

    private String saveFileTPath;

    private String saveFilePath;

    private String saveTestPath;

    public PredmetManager(UserView uv) {
        userView = uv;
        saveFileTPath = Configuration.getProperty("saveFileTPath");
        saveFilePath = Configuration.getProperty("saveFilePath");
        saveTestPath = Configuration.getProperty("saveTestPath");
    }

    public List<PredmetView> findPredmety() {
        ArrayList<PredmetView> predmety = new ArrayList<PredmetView>();
        Connection con = null;
        try {
            con = Database.getConnection();
            if (userView.getStatus().equals(IConstants.STATUS_ROOT)) {
                Statement sql = con.createStatement();
                String query = "SELECT kod, zkratka, nazev FROM predmet_zapis";
                logger.debug(query);
                ResultSet results = sql.executeQuery(query);
                while (results.next()) {
                    predmety.add(createPredmetFormRS(results));
                }
                results.close();
                sql.close();                
            } else if (userView.getStatus().equals(IConstants.STATUS_UCITEL)) {
                Statement sql = con.createStatement();
                String query = "SELECT kod, zkratka, nazev FROM predmet_zapis";
                logger.debug(query);
                ResultSet results = sql.executeQuery(query);
                while (results.next()) {
                    String kod = results.getString("kod");
                    query = "SELECT DISTINCT R.predmet FROM rozvrh R, ucit_roz U WHERE U.ucitel = '"
                        + userView.getLogin() + "' AND U.hodina = R.id AND predmet = '" + kod + '\'';
                    logger.debug(query);
                    Statement sql2 = con.createStatement();
                    ResultSet rset = sql2.executeQuery(query);
                    while (rset.next()) {
                        predmety.add(createPredmetFormRS(results));
                    }
                    rset.close();
                    sql2.close();
                }
                results.close();
                sql.close();                
            } else {
                Statement sql = con.createStatement();
                String query = "SELECT kod,zkratka,nazev FROM predmet_zapis p,zapis z " +
                    "WHERE p.kod = z.predmet " +
                    "AND student = '" + userView.getLogin() + "' " +
                    "AND platnost = 'A'";
                logger.debug(query);
                ResultSet rsetKod = sql.executeQuery(query);
                while (rsetKod.next()) {
                   predmety.add(createPredmetFormRS(rsetKod));
                }
                rsetKod.close();
                sql.close();                                
            }
            con.close();
        } catch (SQLException e) {
            logger.error(e, e);
        }
        return predmety;
    }

    public List<PredmetView> findPredmetyAdd() {
        ArrayList<PredmetView> result = new ArrayList<PredmetView>();
        Connection con = null;
        try {
            con = Database.getConnection();

            ArrayList<PredmetView> predmetyKatis = new ArrayList<PredmetView>();
            Statement sql = con.createStatement();
            String query = "SELECT kod, zkratka, nazev FROM predmet";
            logger.debug(query);
            ResultSet rset = sql.executeQuery(query);
            while (rset.next()) {
                predmetyKatis.add(createPredmetFormRS(rset));
            }
            rset.close();
            sql.close();
            ArrayList<PredmetView> predmetyCviceni = new ArrayList<PredmetView>();
            query = "SELECT kod, zkratka, nazev FROM predmet_zapis";
            logger.debug(query);
            sql = con.createStatement();
            rset = sql.executeQuery(query);
            while (rset.next()) {
                predmetyCviceni.add(createPredmetFormRS(rset));
            }
            rset.close();
            sql.close();
            con.close();
            for (PredmetView predmetKatis : predmetyKatis) {
                boolean in = false;
                for (PredmetView predmetCviceni : predmetyCviceni) {
                    if (predmetCviceni.getKod().equals(predmetKatis.getKod())) {
                        in = true;
                        logger.debug(predmetCviceni.getKod() + " - "
                                + predmetKatis.getKod());
                    }
                }
                if (!in) {
                    result.add(predmetKatis);
                }
            }
        } catch (SQLException e) {
            logger.error(e, e);
        }
        return result;
    }

    public void addPredmet(String kod) {
        Connection con = null;
        try {
            con = Database.getConnection();
            String query = "SELECT kod, zkratka, nazev FROM predmet WHERE kod = '"
                + kod + '\'';
            logger.debug(query);
            Statement sql = con.createStatement();
            ResultSet results = sql.executeQuery(query);
            PredmetView pv = null;
            if (results.next()) {
                pv = createPredmetFormRS(results);
            } else {
                logger.error("Nepodarilo se zapsat predment - neznamy predmet");
                results.close();
                return;
            }
            results.close();
            sql.close();
            // Zapis dat do projektove databaze
            query = "INSERT INTO predmet_zapis VALUES(?,?,?)";
            logger.debug(query);
            PreparedStatement sqlPrep = con.prepareStatement(query);
            sqlPrep.setString(1, pv.getKod());
            sqlPrep.setString(2, pv.getZkratka());
            sqlPrep.setString(3, pv.getNazev());
            sqlPrep.executeUpdate();
            sqlPrep.close();
            con.close();
            File fileAdr = new File(saveFilePath + File.separator
                    + pv.getZkratka());
            File testAdr = new File(saveTestPath + File.separator
                    + pv.getZkratka());
            File fileTAdr = new File(saveFileTPath + File.separator
                    + pv.getZkratka());

            if (fileAdr.exists() == false)
                fileAdr.mkdir();
            if (testAdr.exists() == false)
                testAdr.mkdir();
            if (fileTAdr.exists() == false)
                fileTAdr.mkdir();
        } catch (SQLException e) {
            logger.error(e, e);
        }
    }

    public List<PredmetView> findPredmetyDelete() {
        ArrayList<PredmetView> predmety = new ArrayList<PredmetView>();
        Connection con = null;
        try {
            con = Database.getConnection();
            String query = "SELECT kod, zkratka, nazev FROM predmet_zapis";
            logger.debug(query);
            Statement sql = con.createStatement();
            ResultSet rset = sql.executeQuery(query);
            while (rset.next()) {
                predmety.add(createPredmetFormRS(rset));
            }
            rset.close();
            sql.close();
            con.close();
        } catch (SQLException e) {
            logger.error(e, e);
        }
        return predmety;
    }

    public void deletePredmet(String kod) {
        PredmetView pv = findPredmet(kod);
        if (pv == null) {
            logger.error("Zapsany predmet nebyl nazen");
            return;
        }
        Connection con = null;
        try {
            con = Database.getConnection();
            String query = "DELETE FROM predmet_zapis WHERE kod = ?";
            logger.debug(query);
            PreparedStatement sql = con.prepareStatement(query);
            sql.setString(1, pv.getKod());
            sql.executeUpdate();
            sql.close();
            con.close();
        } catch (SQLException e) {
            logger.error(e, e);
        }

        File FileAdr = new File(saveFilePath + File.separator
                + pv.getZkratka());
        File TestAdr = new File(saveTestPath + File.separator
                + pv.getZkratka());
        File FileTAdr = new File(saveFileTPath + File.separator
                + pv.getZkratka());

        if (FileAdr.exists() == true)
            FileAdr.delete();
        if (TestAdr.exists() == true)
            TestAdr.delete();
        if (FileTAdr.exists() == true)
            FileTAdr.delete();
    }

    public PredmetView findPredmet(String kod) {
        PredmetView predmet = null;
        Connection con = null;
        try {
            con = Database.getConnection();
            String query = "SELECT kod, zkratka, nazev FROM predmet_zapis WHERE kod = '"
                + kod + '\'';
            logger.debug(query);
            Statement sql = con.createStatement();
            ResultSet rset = sql.executeQuery(query);
            if (rset.next()) {
                predmet = createPredmetFormRS(rset);
            }
            rset.close();
            sql.close();                            
            con.close();
        } catch (SQLException e) {
            logger.error(e, e);
        }
        return predmet;
    }

    private PredmetView createPredmetFormRS(ResultSet rs) throws SQLException {
        PredmetView pv = new PredmetView();
        pv.setKod(rs.getString("kod"));
        pv.setZkratka(rs.getString("zkratka"));
        pv.setNazev(rs.getString("nazev"));
        return pv;
    }
}
