package cz.vsb.jtestserver.service;

import cz.vsb.jtestserver.util.Configuration;
import cz.vsb.jtestserver.util.Database;
import cz.vsb.jtestserver.view.PredmetView;
import cz.vsb.jtestserver.view.UlohaView;
import cz.vsb.jtestserver.view.UserView;

import java.io.File;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.log4j.Logger;

public class UlohaManager {

	static Logger logger = Logger.getLogger(UlohaManager.class);

	private UserView userview;

	private String saveFileTPath;

	private String saveFilePath;
	
	private String saveTestPath;

	public UlohaManager(UserView uv) {
		userview = uv;
		saveFileTPath = Configuration.getProperty("saveFileTPath"); 
		saveFilePath = Configuration.getProperty("saveFilePath");
		saveTestPath = Configuration.getProperty("saveTestPath");
	}

	public List<UlohaView> findUlohy(String kod) {
		ArrayList<UlohaView> ulohy = new ArrayList<UlohaView>();
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT * FROM uloha WHERE predmet='"
				+ kod + '\'';
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			while (result.next()) {
				ulohy.add(createHodinaFormRS(result));
			}
                        result.close();
                        sql.close();                
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return ulohy;
	}

	public UlohaView findUloha(int idUlohy) {
		UlohaView uloha = null;
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT * FROM uloha WHERE id_ulohy = "
				+ idUlohy;
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			if (result.next()) {
				uloha = createHodinaFormRS(result);
			}
                        result.close();
                        sql.close();                
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return uloha;
	}

	public void addUloha(String nazevUlohy, String popisUlohy,
			String textUlohy, String jmenoTridy, PredmetView pv) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "INSERT INTO uloha VALUES(null,?,?,?,?,?,?,?,'N','N')";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setString(1, nazevUlohy);
			sql.setString(2, popisUlohy);
			sql.setString(3, textUlohy);
			sql.setString(4, jmenoTridy);
			sql.setString(5, pv.getKod());
			sql.setString(6, getDatum());
			sql.setString(7, userview.getLogin());
			sql.executeUpdate();

			File FileAdr = new File(saveFilePath + File.separator
					+ pv.getZkratka() + File.separator + nazevUlohy);
			File TestAdr = new File(saveTestPath + File.separator
					+ pv.getZkratka() + File.separator + nazevUlohy);
			File FileTAdr = new File(saveFileTPath + File.separator
					+ pv.getZkratka() + File.separator + nazevUlohy);

			if (!FileAdr.exists())
				FileAdr.mkdir();
			if (!TestAdr.exists())
				TestAdr.mkdir();
			if (!FileTAdr.exists())
				FileTAdr.mkdir();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void updateUloha(int idUlohy, String nazevUlohy, String popisUlohy,
			String textUlohy, String jmenoTridy, PredmetView pv) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT * FROM uloha WHERE id_ulohy = "
				+ idUlohy;
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			UlohaView ulohy;
			if (result.next()) {
				ulohy = this.createHodinaFormRS(result);
			} else {
				ulohy = new UlohaView();
			}
                        result.close();
                        sql.close();
			ulohy.setNazevUlohy(nazevUlohy);
			ulohy.setPopisUlohy(popisUlohy);
			ulohy.setTextUlohy(textUlohy);
			ulohy.setJmenoTridy(jmenoTridy);
			ulohy.setPredmet(pv.getKod());
			ulohy.setVlozeno(getDatum());
			ulohy.setLogin(userview.getLogin());

			query = "UPDATE uloha SET nazev_ulohy=?, popis_ulohy=?, "
				+ "text_ulohy=?, jmeno_tridy=?, predmet=?, vlozeno=?, login=?, "
				+ "kompilace=?, testy=? WHERE id_ulohy=?";
			logger.debug(query);
			PreparedStatement sqlPrep = con.prepareStatement(query);
			sqlPrep.setString(1, ulohy.getNazevUlohy());
			sqlPrep.setString(2, ulohy.getPopisUlohy());
			sqlPrep.setString(3, ulohy.getTextUlohy());
			sqlPrep.setString(4, ulohy.getJmenoTridy());
			sqlPrep.setString(5, ulohy.getPredmet());
			sqlPrep.setString(6, ulohy.getVlozeno());
			sqlPrep.setString(7, ulohy.getLogin());
			sqlPrep.setString(8, ulohy.getKompilace());
			sqlPrep.setString(9, ulohy.getTesty());
			sqlPrep.setInt(10, ulohy.getIdUlohy());
			sqlPrep.executeUpdate();
                        sqlPrep.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void deleteUloha(int idUlohy, PredmetView pv) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "SELECT * FROM uloha WHERE id_ulohy = "
				+ idUlohy;
			logger.debug(query);
			Statement sql = con.createStatement();
			ResultSet result = sql.executeQuery(query);
			UlohaView uloha;
			if (result.next()) {
				uloha = this.createHodinaFormRS(result);
			} else {
				uloha = new UlohaView();
			}
                        result.close();
                        sql.close();
			query = "DELETE FROM uloha WHERE id_ulohy = ?";
			logger.debug(query);
			PreparedStatement sqlPrep = con.prepareStatement(query);
			sqlPrep.setInt(1, uloha.getIdUlohy());
			sqlPrep.executeUpdate();
                        sqlPrep.close();
                        con.close();
			File FileAdr = new File(saveFilePath + File.separator
					+ pv.getZkratka() + File.separator + uloha.getNazevUlohy());
			File TestAdr = new File(saveTestPath + File.separator
					+ pv.getZkratka() + File.separator + uloha.getNazevUlohy());
			File FileTAdr = new File(saveTestPath + File.separator
					+ pv.getZkratka() + File.separator + uloha.getNazevUlohy());

			if (FileAdr.exists())
				FileAdr.delete();
			if (TestAdr.exists())
				TestAdr.delete();
			if (FileTAdr.exists())
				FileTAdr.delete();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void updateUlohaKompilace(int idUlohy, String kompilace) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "UPDATE uloha SET  kompilace = ? WHERE id_ulohy = ?";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setString(1, kompilace);
			sql.setInt(2, idUlohy);
			sql.executeUpdate();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	public void updateUlohaTesty(int idUlohy, String testy) {
		Connection con = null;
		try {
			con = Database.getConnection();
			String query = "UPDATE Uloha SET testy = ? WHERE id_ulohy = ?";
			logger.debug(query);
			PreparedStatement sql = con.prepareStatement(query);
			sql.setString(1, testy);
			sql.setInt(2, idUlohy);
			sql.executeUpdate();
		} catch (SQLException e) {
			logger.error(e, e);
		}
	}

	private UlohaView createHodinaFormRS(ResultSet rs) throws SQLException {
		UlohaView ulohaView = new UlohaView();
		ulohaView.setIdUlohy(rs.getInt("id_ulohy"));
		ulohaView.setNazevUlohy(rs.getString("nazev_ulohy"));
		ulohaView.setPopisUlohy(rs.getString("popis_ulohy"));
		ulohaView.setTextUlohy(rs.getString("text_ulohy"));
		ulohaView.setJmenoTridy(rs.getString("jmeno_tridy"));
		ulohaView.setPredmet(rs.getString("predmet"));
		ulohaView.setVlozeno(rs.getString("vlozeno"));
		ulohaView.setLogin(rs.getString("login"));
		ulohaView.setKompilace(rs.getString("kompilace"));
		ulohaView.setTesty(rs.getString("testy"));
		return ulohaView;
	}

	private String getDatum() {
		return DateFormat.getDateTimeInstance(DateFormat.LONG, DateFormat.LONG)
				.format((new Date()));
	}
}
