package cz.vsb.jtestserver.service;

import cz.vsb.jtestserver.util.Database;
import cz.vsb.jtestserver.view.VysledkyView;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

public class VysledkyManager {

	static Logger logger = Logger.getLogger(VysledkyManager.class);
	
	public List<VysledkyView> findVysledkyStudentu(Integer idRozvrhu,
			Integer idCviceni) {
		ArrayList<VysledkyView> vysledky = new ArrayList<VysledkyView>();
		Connection con = null;
		try {
			con = Database.getConnection();
			StringBuilder querySB = new StringBuilder();
			querySB.append("SELECT v.login, u.nazev_ulohy, COUNT(v.id_ulohy) ");
			querySB.append("AS pocet_pokusu, SUM(v.pocet_eroru) AS pocet_eroru, ");
			querySB.append("SUM(v.pocet_failu) AS pocet_failu, MAX(odevzdano), ");
			querySB.append("SUM(v.vysledek) AS vysledek FROM vysledky v, uloha u WHERE ");
			querySB.append(" v.id_rozvrhu = ");
			querySB.append(idRozvrhu);
			querySB.append(" AND v.id_cviceni = ");
			querySB.append(idCviceni);
			querySB.append(" AND v.id_ulohy = u.id_ulohy GROUP BY v.login, v.id_ulohy");
			logger.debug(querySB.toString());
			Statement sql = con.createStatement();
			ResultSet rsetVys = sql.executeQuery(querySB.toString());
			while (rsetVys.next()) {
				VysledkyView vv = this.createVysledkyFromRSet(rsetVys);
				
				String query = "SELECT jmeno, prijmeni FROM auth WHERE login = '"
					+ vv.getLogin() + '\'';
				logger.debug(query);
				sql = con.createStatement();
				ResultSet rsetJmena = sql.executeQuery(query);
				if (rsetJmena.next()) {
					vv.setJmeno(rsetJmena.getString(1));
					vv.setPrijmeni(rsetJmena.getString(1));
				}
				vysledky.add(vv);
                                rsetJmena.close();
                                sql.close();
			}
                        rsetVys.close();
                        sql.close();
                        con.close();
		} catch (SQLException e) {
			logger.error(e, e);
		}
		return vysledky;
	}

	private VysledkyView createVysledkyFromRSet(ResultSet rs)
			throws SQLException {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		VysledkyView vv = new VysledkyView();
		vv.setLogin(rs.getString(1));
		vv.setNazevUlohy(rs.getString(2));
		vv.setPocetPokusu(rs.getInt(3));
		vv.setPocetError(rs.getInt(4));
		vv.setPocetFail(rs.getInt(5));
		vv.setCas(sdf.format(rs.getTimestamp(6)));
		vv.setVysledek(rs.getInt(7));
		return vv;
	}
}
