package cz.vsb.jtestserver.util;

import java.util.Enumeration;
import java.util.Locale;
import java.util.Map;
import java.util.Properties;
import java.util.PropertyResourceBundle;

public class Configuration {
	public static final String VERSION_NUMBER = "version.number";

	public static final String VERSION_TEST = "version.test";

	public static final String LOG_LINESPERPAGE = "log.linesPerPage";

	public static final String DEFAULT_USER = "default.user";

	public static final String DEFAULT_CONTEXT = "default.context";

	public static final String DATASOURCE = "datasource";

	private static Properties defaults;

	private static Properties properties;

	public static void init(String name) {
		defaults = new Properties();
		// Implicitni hodnoty. Mely by se tu objevit implicitni hodnoty
		// vsech vlastnosti, ktere jsou pro korektni funkci systemu klicove,
		// to znamena vsechny :-)
		defaults.put(VERSION_NUMBER, "1.0");
		defaults.put(VERSION_TEST, "true");
		defaults.put(LOG_LINESPERPAGE, "30");
		defaults.put(DEFAULT_USER, "");
		defaults.put(DEFAULT_CONTEXT, "");

		properties = new Properties(defaults);
		PropertyResourceBundle bundle = (PropertyResourceBundle) PropertyResourceBundle
				.getBundle(name);
		Enumeration<String> e = bundle.getKeys();
		while (e.hasMoreElements()) {
			String key = e.nextElement();
			String value = bundle.getString(key);
			properties.setProperty(key, value);
		}

		// Nastaveni cestiny pro ruzne formatovaci utility, napriklad
		// SimpleDateFormat a podobne.
		Locale.setDefault(new Locale("cs"));

	}

	public static Properties getProperties(String key) {
		String prefix = key + '.';
		int start = prefix.length();

		Properties map = new Properties();
		for (Map.Entry entry : properties.entrySet()) {
			String k = (String) entry.getKey();
			if (k.startsWith(key)) {
				map.put(k.substring(start), entry.getValue());
			}
		}

		return map;
	}

	public static String getProperty(String key) {
		return properties.getProperty(key);
	}
}
