package cz.vsb.jtestserver.util;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 *
 * <p>Title: Server pro automaticke testovani java aplikaci</p>
 *
 * <p>Description: Trida pro pristup k databazi MySQL</p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * @author Tomas Marianek (MAR560)
 * @version 1.0
 */

public class DbMySql {

    private Connection connection;
    private Statement statement;
    private String adresa_serveru;
    private String jmeno_databaze;
    private String login;
    private String heslo;

    /**
     *
     * @param adr_serveru String
     * @param jmeno_data String
     * @param strLogin String
     * @param strHeslo String
     */
    public DbMySql(String adr_serveru, String jmeno_data, String strLogin,
                   String strHeslo) {
        adresa_serveru = adr_serveru;
        jmeno_databaze = jmeno_data;
        login = strLogin;
        heslo = strHeslo;
    }
    /**
     *
     * @throws ClassNotFoundException
     * @throws SQLException
     */
    public void DoConnect() throws ClassNotFoundException, SQLException {
        Class.forName("com.mysql.jdbc.Driver");
  //       Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        connection = DriverManager.getConnection("jdbc:mysql://" +
                                                 adresa_serveru + "/" +
                                                 jmeno_databaze +
                                                 "?useUnicode=true&characterEncoding=utf8&characterSetResults=utf8",
                                                 login,
                                                 heslo);
        statement = connection.createStatement();
    }
    /**
     *
     * @param dotaz String
     * @return ResultSet
     * @throws SQLException
     */
    public ResultSet executeQuery(String dotaz) throws SQLException {
        return statement.executeQuery(dotaz);
    }
    /**
     *
     * @param sqlCommand String
     * @throws SQLException
     */
    public void executeUpdate(String sqlCommand) throws SQLException {
        statement.executeUpdate(sqlCommand);
    }
    /**
     *
     * @throws SQLException
     */
    public void commit() throws SQLException {
        connection.commit();
    }
    /**
     *
     * @throws SQLException
     */
    public void rollback() throws SQLException {
        connection.rollback();
    }
    /**
     *
     * @throws SQLException
     */
    protected void finalize() throws SQLException {
        statement.close();
        connection.close();
    }
}
