package cz.vsb.jtestserver.util;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.File;

import org.apache.log4j.Logger;

public class FileUpload {
	static Logger logger = Logger.getLogger(FileUpload.class);
	
	private static int BUFFER_SIZE = 8192;

	public boolean doUpload(InputStream in, String fileName,
			String savePath) {
		String path = savePath + File.separator + fileName;
		try {
			FileOutputStream out = new FileOutputStream(path);
			int off = 0;
			int bytesRead = 0;
			byte[] buffer = new byte[BUFFER_SIZE];
			while ((bytesRead = in.read(buffer))!= -1) {
				out.write(buffer, 0, bytesRead);				
			}
			out.close();
			return true;
		} catch (FileNotFoundException e) {
			logger.error(e, e);
			return false;
		} catch (IOException e) {
			logger.error(e, e);
			return false;
		}

	}
}